package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.ColumnDataFeign;
import com.steerinfo.dil.model.AmsSaleOrderMaterial;
import com.steerinfo.dil.model.AmsSaleTrucknoMaterial;
import com.steerinfo.dil.service.IAmsSaleTrucknoMaterialService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * AmsSaleTrucknoMaterial RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-11-16 10:12
 * 类描述
 * 修订历史：
 * 日期：2021-11-16
 * 作者：generator
 * 参考：
 * 描述：AmsSaleTrucknoMaterial RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/amssaletrucknomaterials")
public class AmsSaleTrucknoMaterialController extends BaseRESTfulController {

    @Autowired
    IAmsSaleTrucknoMaterialService amsSaleTrucknoMaterialService;

    @Autowired
    ColumnDataFeign columnDataFeign;

    @Autowired
    ColumnDataUtil columnDataUtil;

    @ApiOperation(value="查询销售订单车序号详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "apiId(170)", value = "表头", required = false, dataType = "Interger")
    })
    @PostMapping("/getTruckNoDetail")
    public RESTfulResult getTruckNoDetail(BigDecimal saleOrderMaterialId,@RequestBody(required=false) Map<String,Object> mapValue,
                                            Integer apiId,
                                            Integer pageNum,
                                            Integer pageSize){
        if (mapValue == null) {
            mapValue = new HashMap<>();
        }
        mapValue.put("saleOrderMaterialId",saleOrderMaterialId);
        List<Map<String, Object>> amsTruckNoDetail = amsSaleTrucknoMaterialService.getTruckNoDetail(mapValue);
        PageHelper.startPage(pageNum,pageSize);
        List<Map<String, Object>> amsTruckNoDetail1 = amsSaleTrucknoMaterialService.getTruckNoDetail(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, amsTruckNoDetail,amsTruckNoDetail1);
        return success(pageList);
    }

    /**
     * 新增车序号物资信息
     * @param amsSaleTrucknoMaterial
     * @return
     */
    @ApiOperation(value="新增车序号物资信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "amsSaleTrucknoMaterial", value = "新增车序号物资对象", required = false, dataType = "AmsSaleTrucknoMaterial")
    })
    @PostMapping(value = "/addAmsSaleTrucknoMaterial")
    public RESTfulResult addAmsSaleTrucknoMaterial(@RequestBody(required = false) AmsSaleTrucknoMaterial amsSaleTrucknoMaterial){
        int i = amsSaleTrucknoMaterialService.addAmsSaleTrucknoMaterial(amsSaleTrucknoMaterial);
        return success(i);
    }

    /**
     * 通过主键删除车序号物资信息
     * @param trucknoMaterialId
     * @return
     */
    @ApiOperation(value="通过主键删除车序号物资信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "trucknoMaterialId", value = "主键Id", required = false, dataType = "java.math.BigDecimal")
    })
    @PostMapping(value = "/deleteAmsSaleTrucknoMaterial")
    public RESTfulResult deleteAmsSaleTrucknoMaterial(BigDecimal trucknoMaterialId){
        int i = amsSaleTrucknoMaterialService.deleteAmsSaleTrucknoMaterial(trucknoMaterialId);
        return success(i);
    }

    /**
     * 通过主键渲染车序号物资信息
     * @param trucknoMaterialId
     * @return
     */
    @ApiOperation(value="通过主键渲染车序号物资信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "saleOrderMaterialId", value = "主键Id", required = false, dataType = "java.math.BigDecimal")
    })
    @PostMapping(value = "/getAmsSaleTrucknoMaterial")
    public RESTfulResult getAmsSaleTrucknoMaterial(@RequestParam BigDecimal trucknoMaterialId){
        List<Map<String, Object>> maps = amsSaleTrucknoMaterialService.getAmsSaleTrucknoMaterial(trucknoMaterialId);
        return success(maps);
    }

    /**
     * 通过主键修改车序号物资信息
     * @param amsSaleTrucknoMaterial
     * @return
     */
    @ApiOperation(value="通过主键修改车序号物资信息")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "amsSaleTrucknoMaterial", value = "车序号物资信息对象", required = false, dataType = "AmsSaleTrucknoMaterial")
    })
    @PostMapping(value = "/updateAmsSaleTrucknoMaterial")
    public RESTfulResult updateAmsSaleTrucknoMaterial(@RequestBody(required = false) AmsSaleTrucknoMaterial amsSaleTrucknoMaterial){
        int i = amsSaleTrucknoMaterialService.updateAmsSaleTrucknoMaterial(amsSaleTrucknoMaterial);
        return success(i);
    }
}
