package com.steerinfo.dil.controller;

import com.steerinfo.dil.feign.ColumnDataFeign;
import com.steerinfo.dil.feign.ESFeign;
import com.steerinfo.dil.service.IAmstruckSporadicOrderService;
import com.steerinfo.dil.util.BaseRESTfulController;
import com.steerinfo.dil.util.ColumnDataUtil;
import com.steerinfo.dil.util.PageListAdd;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageHelper;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * AmstruckSporadicOrder RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-12-16 02:49
 * 类描述
 * 修订历史：
 * 日期：2021-12-16
 * 作者：generator
 * 参考：
 * 描述：AmstruckSporadicOrder RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/amstrucksporadicorders")
public class AmstruckSporadicOrderController extends BaseRESTfulController {

    @Autowired
    IAmstruckSporadicOrderService amstruckSporadicOrderService;
    @Autowired
    ColumnDataUtil columnDataUtil;
    @Autowired
    ColumnDataFeign columnDataFeign;
    @Autowired
    ESFeign esFeign;


    @ApiOperation(value="新增零星物资进出厂（以及销售钢材退货）,包括内转精煤")
    @PostMapping("/addSporadicOrders")
    public RESTfulResult addSporadicOrders(@RequestBody Map<String,Object> mapValue) {
        int result = amstruckSporadicOrderService.addSporadicOrder(mapValue);
        return success(result);
    }

    @ApiOperation(value="下发零星物资订单")
    @PostMapping("/issueSporadicOrders")
    public RESTfulResult issueSporadicOrders(@RequestBody List<Map<String, Object>> mapList) {
        int result = amstruckSporadicOrderService.issueSporadicOrders(mapList);
        return success(result);
    }

    @ApiOperation(value="逻辑删除零星物资订单")
    @PostMapping("/deleteSporadicOrders")
    public RESTfulResult deleteSporadicOrders(@RequestParam Integer sporadicOrderId) {
        int result = amstruckSporadicOrderService.deleteSporadicOrders(sporadicOrderId);
        return success(result);
    }

    @ApiOperation(value="查询零星物资订单列表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "apiId", value = "384", required = false, dataType = "Integer")
    })
    @PostMapping("/getSporadicOrdersList")
    public RESTfulResult getSporadicOrdersList(@RequestBody(required=false) Map<String,Object> mapValue,
                                               Integer apiId,
                                               Integer pageNum,
                                               Integer pageSize,
                                               Integer orderType,
                                               Integer issueStatus,
                                               String con,
                                               Integer dispatchStatus) {
        if (con != null && !con.equals("undefined")) {
            String index="get_sporadic_order_list";//设置要查询的索引名称
            return success(esFeign.getConResult(mapValue,index,apiId,pageNum,pageSize,con));//获取查询结果
        }
        mapValue.put("orderType",orderType);
        mapValue.put("issueStatus",issueStatus);
        if (dispatchStatus!=null){
            mapValue.put("dispatchStatus",dispatchStatus);
        }
        List<Map<String, Object>> sporadicOrderList = null;
        if (mapValue.size() == 3) {
            //将查询结果存入索引中
            sporadicOrderList =  amstruckSporadicOrderService.getSporadicOrdersList(mapValue);
            Map<String, Object> map1 = new HashMap<>();
            //添加索引
            map1.put("index","get_sporadic_order_list");
            //添加id
            map1.put("indexId","sporadicOrderId");
            sporadicOrderList.add(map1);
            //新建索引
            esFeign.insertIndex(sporadicOrderList);
            //删除
            sporadicOrderList.remove(sporadicOrderList.size()-1);
        }
        if (sporadicOrderList == null) {
            sporadicOrderList = amstruckSporadicOrderService.getSporadicOrdersList(mapValue);
        }
        PageHelper.startPage(pageNum,pageSize);
        List<Map<String, Object>> columnList = amstruckSporadicOrderService.getSporadicOrdersList(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, sporadicOrderList,columnList);
        return success(pageList);
    }

    @ApiOperation(value="查看物资详情")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "apiId", value = "385", required = false, dataType = "Integer")
    })
    @PostMapping("/seeAllMaterials")
    public RESTfulResult seeAllMaterials(@RequestBody(required = false) Map<String,Object> mapValue,
                                         Integer apiId,
                                         Integer pageNum,
                                         Integer pageSize,
                                         Integer sporadicOrderId,
                                         String con) {
        if (con != null && !con.equals("undefined")) {
            String index="see_all_materials";//设置要查询的索引名称
            return success(esFeign.getConResult(mapValue,index,apiId,pageNum,pageSize,con));//获取查询结果
        }
        mapValue.put("sporadicOrderId",sporadicOrderId);
        List<Map<String, Object>> mapList = null;
        if (mapValue.size() == 1) {
            //将查询结果存入索引中
            mapList =  amstruckSporadicOrderService.seeAllMaterials(mapValue);
            Map<String, Object> map1 = new HashMap<>();
            //添加索引
            map1.put("index","see_all_materials");
            //添加id
            map1.put("indexId","materialId");
            mapList.add(map1);
            //新建索引
            esFeign.insertIndex(mapList);
            //删除
            mapList.remove(mapList.size()-1);
        }
        if (mapList == null) {
            mapList = amstruckSporadicOrderService.seeAllMaterials(mapValue);
        }
        PageHelper.startPage(pageNum,pageSize);
        List<Map<String, Object>> columnList = amstruckSporadicOrderService.getSporadicOrdersList(mapValue);
        PageListAdd pageList = columnDataUtil.tableColumnData(apiId, mapList,columnList);
        return success(pageList);
    }

    @ApiOperation(value="修改零星物资订单")
    @PostMapping("/updateSporadicOrder")
    public RESTfulResult updateSporadicOrder(@RequestBody Map<String,Object> mapValue) {
        int result = amstruckSporadicOrderService.updateSporadicOrder(mapValue);
        return success(result);
    }

    @ApiOperation(value="查询修改渲染")
    @PostMapping("/selectSporadicOrder")
    public RESTfulResult selectSporadicOrder(@RequestParam Integer sporadicOrderId) {
        List<Map<String, Object>> mapList = amstruckSporadicOrderService.selectSporadicOrder(sporadicOrderId);
        return success(mapList);
    }



    @ApiOperation(value="零星一车多趟新增订单")
    @PostMapping("/addSporadicOrderTimes")
    public RESTfulResult addSporadicOrderTimes(@RequestBody Map<String,Object> map) {
       int i=amstruckSporadicOrderService.addSporadicOrderforTimes(map);
        return success(i);
    }


}
