package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.AmsContractTransportPrice;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface AmsContractTruckPriceMapper extends IBaseMapper<AmsContractTransportPrice, BigDecimal> {
    //查询主键最大值
    BigDecimal selectMaxId();
    //获取汽运单价信息
    List<Map<String, Object>> getAmsContractTransportPrice(Map<String,Object> map);
    //获取承运商名称
    List<Map<String, Object>> getCarrierName();
    //获取线路编号
    List<Map<String, Object>> getLineNo();
    //获取运力编号
    List<Map<String, Object>> getCapacityNumber();
    //获取收货地址
    List<Map<String, Object>> getAddressDeliveryAddress(Map<String,Object> map);
    //获取要渲染的信息
    List<Map<String, Object>> selectByPriceId(BigDecimal priceId);
    //获取所有的油价
    List<Map<String, Object>> getOriginAndNowOilPrice();
    //通过油价变动率批量修改油价
    int batchUpdateTransportPriceByOilPrice(Double updateOilPrice);
    //通过主键查询参考运距
    BigDecimal getLinePathLength(BigDecimal lineId);
    //获取运价和吨公里数值列表
    List<Map<String, Object>> getPriceValueAndPriceTonKilometer();
    //通过主键修改吨公里数
    int updatePriceTonKilometer(BigDecimal priceId,BigDecimal priceTonKilometer);
}