package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.AmsSaleOrderMaterial;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface AmsSaleOrderMaterialMapper extends IBaseMapper<AmsSaleOrderMaterial, BigDecimal> {
    //查询主键最大值
    @Select("select seq_AMS_SALE_ORDER_MATERIAL.nextval from dual")
    BigDecimal selectMaxId();
    //查询收货地址主键最大值
    BigDecimal selectMaxIdReceive();
    //新增收货地址
    int insertReceiveAddress(Map<String, Object> map);
    //获取要渲染的值
    List<Map<String, Object>> selectBySaleOrderMaterialId(BigDecimal saleOrderMaterialId);
    //通过主键获得收货地址
    String getAddress(BigDecimal saleOrderMaterialId);
    //获取收货地址id
    BigDecimal getReceiveAddressId(String saleShippingAddress);
    //获取收货地址
    List<Map<String, Object>> getAddressDeliveryAddress();
    List<Map<String, Object>> getSaleMaterial(Map<String, Object> mapValue);

    Integer selectById(BigDecimal saleOrderMaterialId);

    Integer selectByCxh(Map<String, Object> m);

    // 车序号信息
    List<Map<String, Object>> getTruckNoList(Map<String, Object> mapValue);

    // 物资详情
    List<Map<String, Object>> getTruckNoMaterialList(BigDecimal saleOrderMaterialId);

    // 销售订单下的
    List<Map<String, Object>> getSaleMaterialList(BigDecimal saleOrderId);

    // 通过车牌号查询运力id
    BigDecimal getCapacityId(String capacityNumber);

    //计算同一销售订单的物资重量
    BigDecimal getMaterialWeightByOrderId(BigDecimal saleOrderId);
    //计算同一销售下的物资总净量
    BigDecimal getMaterialNetWeightBySaleId(BigDecimal saleOrderId);
}