package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="运输单价")
public class AmsContractTransportPrice implements IBasePO<BigDecimal> {
    /**
     * 主键ID(PRICE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal priceId;

    /**
     * 托运人ID(SHIPPER_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="托运人ID",required=false)
    private BigDecimal shipperId;

    /**
     * 承运商ID(CARRIER_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="承运商ID",required=false)
    private BigDecimal carrierId;

    /**
     * 运输线路ID(LINE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="运输线路ID",required=false)
    private BigDecimal lineId;

    /**
     * 运力ID(CAPACITY_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="运力ID",required=false)
    private BigDecimal capacityId;

    /**
     * 物资ID(MATERIAL_ID,CHAR,10)
     */
    @ApiModelProperty(value="物资ID",required=false)
    private String materialId;

    /**
     * 吨公里（元/吨.km）(PRICE_TON_KILOMETER,DECIMAL,0)
     */
    @ApiModelProperty(value="吨公里（元/吨.km）",required=false)
    private BigDecimal priceTonKilometer;

    /**
     * 运价（保留两位小数）(PRICE_VALUE,DECIMAL,0)
     */
    @ApiModelProperty(value="运价（保留两位小数）",required=false)
    private BigDecimal priceValue;

    /**
     * 执行日期(PRICE_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="执行日期",required=false)
    private Date priceDate;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 逻辑删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除",required=false)
    private BigDecimal deleted;

    /**
     * 收货地址ID(ADDRESS_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="收货地址ID",required=false)
    private BigDecimal addressId;

    /**
     * 类型：1为销售 2为内转 3为采购水运 4为采购汽运(TYPE,DECIMAL,0)
     */
    @ApiModelProperty(value="类型：1为销售 2为内转 3为采购水运 4为采购汽运",required=false)
    private BigDecimal type;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.priceId;
    }

    @Override
    public void setId(BigDecimal priceId) {
        this.priceId = priceId;
    }

    public BigDecimal getPriceId() {
        return priceId;
    }

    public void setPriceId(BigDecimal priceId) {
        this.priceId = priceId;
    }

    public BigDecimal getShipperId() {
        return shipperId;
    }

    public void setShipperId(BigDecimal shipperId) {
        this.shipperId = shipperId;
    }

    public BigDecimal getCarrierId() {
        return carrierId;
    }

    public void setCarrierId(BigDecimal carrierId) {
        this.carrierId = carrierId;
    }

    public BigDecimal getLineId() {
        return lineId;
    }

    public void setLineId(BigDecimal lineId) {
        this.lineId = lineId;
    }

    public BigDecimal getCapacityId() {
        return capacityId;
    }

    public void setCapacityId(BigDecimal capacityId) {
        this.capacityId = capacityId;
    }

    public String getMaterialId() {
        return materialId;
    }

    public void setMaterialId(String materialId) {
        this.materialId = materialId == null ? null : materialId.trim();
    }

    public BigDecimal getPriceTonKilometer() {
        return priceTonKilometer;
    }

    public void setPriceTonKilometer(BigDecimal priceTonKilometer) {
        this.priceTonKilometer = priceTonKilometer;
    }

    public BigDecimal getPriceValue() {
        return priceValue;
    }

    public void setPriceValue(BigDecimal priceValue) {
        this.priceValue = priceValue;
    }

    public Date getPriceDate() {
        return priceDate;
    }

    public void setPriceDate(Date priceDate) {
        this.priceDate = priceDate;
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public BigDecimal getAddressId() {
        return addressId;
    }

    public void setAddressId(BigDecimal addressId) {
        this.addressId = addressId;
    }

    public BigDecimal getType() {
        return type;
    }

    public void setType(BigDecimal type) {
        this.type = type;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", priceId=").append(priceId);
        sb.append(", shipperId=").append(shipperId);
        sb.append(", carrierId=").append(carrierId);
        sb.append(", lineId=").append(lineId);
        sb.append(", capacityId=").append(capacityId);
        sb.append(", materialId=").append(materialId);
        sb.append(", priceTonKilometer=").append(priceTonKilometer);
        sb.append(", priceValue=").append(priceValue);
        sb.append(", priceDate=").append(priceDate);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", addressId=").append(addressId);
        sb.append(", type=").append(type);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}