package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="销售订单和物资的中间表")
public class AmsSaleOrderMaterial implements IBasePO<BigDecimal> {
    /**
     * 主键ID(SALE_ORDER_MATERIAL_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal saleOrderMaterialId;

    /**
     * 销售订单ID(SALE_ORDER_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="销售订单ID",required=true)
    private BigDecimal saleOrderId;

    /**
     * 车序号(SALE_ORDER_MATERIAL_TRUCK_NO,DECIMAL,0)
     */
    @ApiModelProperty(value="车序号",required=false)
    private BigDecimal saleOrderMaterialTruckNo;

    /**
     * 收货地址ID(SALE_SHIPPING_ADDRESS_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="收货地址ID",required=false)
    private BigDecimal saleShippingAddressId;

    /**
     * 发货日期(SALE_DATE_OF_RECEIPT,TIMESTAMP,7)
     */
    @ApiModelProperty(value="发货日期",required=false)
    private Date saleDateOfReceipt;

    /**
     * 收货方姓名(SALE_ORDER_CONSIGNEE,VARCHAR,20)
     */
    @ApiModelProperty(value="收货方姓名",required=false)
    private String saleOrderConsignee;

    /**
     * 收货方电话(SALE_ORDER_CONSIGNEE_TEL,VARCHAR,20)
     */
    @ApiModelProperty(value="收货方电话",required=false)
    private String saleOrderConsigneeTel;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 是否删除（0：否，1：是）(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="是否删除（0：否，1：是）",required=false)
    private BigDecimal deleted;

    /**
     * 是否为历史记录（0：否，1：是）(UPDATED,DECIMAL,0)
     */
    @ApiModelProperty(value="是否为历史记录（0：否，1：是）",required=false)
    private BigDecimal updated;

    /**
     * 下发状态(0:未下发；1:已下发 2:已下发给承运商)(ISSUE_STATUS,DECIMAL,0)
     */
    @ApiModelProperty(value="下发状态(0:未下发；1:已下发 2:已下发给承运商)",required=false)
    private BigDecimal issueStatus;

    /**
     * 钢材收货日期(STEEL_RECEIPT_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="钢材收货日期",required=false)
    private Date steelReceiptDate;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.saleOrderMaterialId;
    }

    @Override
    public void setId(BigDecimal saleOrderMaterialId) {
        this.saleOrderMaterialId = saleOrderMaterialId;
    }

    public BigDecimal getSaleOrderMaterialId() {
        return saleOrderMaterialId;
    }

    public void setSaleOrderMaterialId(BigDecimal saleOrderMaterialId) {
        this.saleOrderMaterialId = saleOrderMaterialId;
    }

    public BigDecimal getSaleOrderId() {
        return saleOrderId;
    }

    public void setSaleOrderId(BigDecimal saleOrderId) {
        this.saleOrderId = saleOrderId;
    }

    public BigDecimal getSaleOrderMaterialTruckNo() {
        return saleOrderMaterialTruckNo;
    }

    public void setSaleOrderMaterialTruckNo(BigDecimal saleOrderMaterialTruckNo) {
        this.saleOrderMaterialTruckNo = saleOrderMaterialTruckNo;
    }

    public BigDecimal getSaleShippingAddressId() {
        return saleShippingAddressId;
    }

    public void setSaleShippingAddressId(BigDecimal saleShippingAddressId) {
        this.saleShippingAddressId = saleShippingAddressId;
    }

    public Date getSaleDateOfReceipt() {
        return saleDateOfReceipt;
    }

    public void setSaleDateOfReceipt(Date saleDateOfReceipt) {
        this.saleDateOfReceipt = saleDateOfReceipt;
    }

    public String getSaleOrderConsignee() {
        return saleOrderConsignee;
    }

    public void setSaleOrderConsignee(String saleOrderConsignee) {
        this.saleOrderConsignee = saleOrderConsignee == null ? null : saleOrderConsignee.trim();
    }

    public String getSaleOrderConsigneeTel() {
        return saleOrderConsigneeTel;
    }

    public void setSaleOrderConsigneeTel(String saleOrderConsigneeTel) {
        this.saleOrderConsigneeTel = saleOrderConsigneeTel == null ? null : saleOrderConsigneeTel.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    public BigDecimal getUpdated() {
        return updated;
    }

    public void setUpdated(BigDecimal updated) {
        this.updated = updated;
    }

    public BigDecimal getIssueStatus() {
        return issueStatus;
    }

    public void setIssueStatus(BigDecimal issueStatus) {
        this.issueStatus = issueStatus;
    }

    public Date getSteelReceiptDate() {
        return steelReceiptDate;
    }

    public void setSteelReceiptDate(Date steelReceiptDate) {
        this.steelReceiptDate = steelReceiptDate;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", saleOrderMaterialId=").append(saleOrderMaterialId);
        sb.append(", saleOrderId=").append(saleOrderId);
        sb.append(", saleOrderMaterialTruckNo=").append(saleOrderMaterialTruckNo);
        sb.append(", saleShippingAddressId=").append(saleShippingAddressId);
        sb.append(", saleDateOfReceipt=").append(saleDateOfReceipt);
        sb.append(", saleOrderConsignee=").append(saleOrderConsignee);
        sb.append(", saleOrderConsigneeTel=").append(saleOrderConsigneeTel);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", updated=").append(updated);
        sb.append(", issueStatus=").append(issueStatus);
        sb.append(", steelReceiptDate=").append(steelReceiptDate);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}