package com.steerinfo.dil.service;

import com.steerinfo.dil.model.AmsSaleOrderMaterial;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * AmsSaleOrderMaterial服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-06 07:10
 * 类描述
 * 修订历史：
 * 日期：2021-09-06
 * 作者：generator
 * 参考：
 * 描述：AmsSaleOrderMaterial服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface IAmsSaleOrderMaterialService{
    //新增销售订单物资信息
    int addAmsSaleOrderMaterial(AmsSaleOrderMaterial amsSaleOrderMaterial);
    //获取要渲染的值
    List<Map<String, Object>> selectBySaleOrderMaterialId(BigDecimal saleOrderMaterialId);
    //修改销售订单物资信息
    int updateAmsSaleOrderMaterial(AmsSaleOrderMaterial amsSaleOrderMaterial);
    //通过主键删除销售订单物资信息
    int deleteAmsSaleOrderMaterialBySaleOrderMaterialId(BigDecimal saleOrderMaterialId);
    //通过主键获得收货地址
    String getAddress(BigDecimal saleOrderMaterialId);
    //通过主键修改销售订单信息(新增一条），过去的成为历史记录
    int updateAddress(Map<String, Object> map);
    //获取收货地址
    List<Map<String, Object>> getAddressDeliveryAddress();

    List<Map<String, Object>> getSaleMaterial(Map<String, Object> mapValue);
    Integer selectById(BigDecimal saleOrderMaterialId);

    Integer selectByCxh(Map<String, Object> m);

    // 车序号信息
    List<Map<String, Object>> getTruckNoList(Map<String, Object> mapValue);

    // 添加车序号与物资
    int addTruckNo(List<Map<String, Object>> mapList);

    // 下发车序号
    int issueTruckNo(List<Map<String, Object>> mapList);

    // 展示车序号下的物资详情
    List<Map<String, Object>> getTruckNoMaterialList(BigDecimal saleOrderMaterialId);

    // 销售订单下的物资
    List<Map<String, Object>> getSaleMaterialList(BigDecimal saleOrderId);

    // 销售直接派发销售订单
    int dispatchTruckOrderBySale(Map<String, Object> mapValue);

}