package com.steerinfo.dil.service;

import com.steerinfo.dil.model.AmsSaleOrder;
import com.steerinfo.dil.model.AmsSaleOrderMaterial;

import java.math.BigDecimal;
import java.text.ParseException;
import java.util.List;
import java.util.Map;

/**
 * AmsSaleOrder服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-06 07:10
 * 类描述
 * 修订历史：
 * 日期：2021-09-06
 * 作者：generator
 * 参考：
 * 描述：AmsSaleOrder服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface IAmsSaleOrderService {
    //查询所有未上报销售订单信息
    List<Map<String, Object>> getSaleOrderInfo(Map<String, Object> map);

    //查询所有已上报销售订单信息
    List<Map<String, Object>> getSaleOrderReported(Map<String, Object> map);

    //根据车序号查询销售订单详细
    List<Map<String, Object>> getSaleOrderDetail(Map<String, Object> map);

    //获取销售计划名称
    List<Map<String, Object>> getSalePlanName();

    //获取发货单位
    List<Map<String, Object>> getShipperName();

    //获取收货单位
    List<Map<String, Object>> getConsigneeCompanyName();

    //新增销售订单
    int addAmsSaleOrder(Map<String, Object> map) throws ParseException;

    //修改销售订单状态为已上报
    int uploadSaleOrder(BigDecimal saleOrderId);

    //获取要渲染的数据
    List<Map<String, Object>> selectBySaleOrderId(BigDecimal saleOrderId);

    //修改销售订单信息
    int updateAmsSaleOrder(Map<String,Object> map) throws ParseException;

    //通过主键删除销售订单及其从表使用信息
    int deleteAmsSaleOrderBySaleOrderId(BigDecimal saleOrderId);

    //查询所有财务已经审批的销售订单
    List<Map<String, Object>> getAmsSaleOrderApproved(Map<String, Object> map);

    //通过销售订单号查询销售订单的修改日志
    List<Map<String, Object>> getSaleOrderUpdateLog(Map<String, Object> map);


    //获取销售公司已审核的订单
    List<Map<String,Object>> getSaleOrderListBySaleCompany(Map<String,Object> map);

    //获得销售订单号
    List<Map<String, Object>> getSaleOrderList(Map<String, Object> mapValue);

    //获得承运商
    Map<String,Object> getCarrier(Integer addressId);



    //根据销售订单id查找基础信息，渲染数据
    Map<String, Object> selectInfoBySaleOrderId(BigDecimal saleOrderId);

    //根据销售订单id查找物资信息，渲染数据
    List<Map<String,Object>> selectMaterialInfoBySaleOrderId(BigDecimal saleOrderId);

    int addAmsDispatchSaleOrder(List<Map<String, Object>> mapValue);

    //查询未上报销售订单信息
    List<Map<String, Object>> getSaleOrderInfoes(Map<String, Object> map);

    //查询所有已上报销售订单信息
    List<Map<String, Object>> getSaleOrderReportedes(Map<String, Object> map);

    //获取销售公司已审核的订单
    List<Map<String,Object>> getSaleOrderListBySaleCompanyes(Map<String,Object> map);

    //查询所有财务已经审批的销售订单
    List<Map<String, Object>> getAmsSaleOrderApprovedes(Map<String, Object> map);

    List<Map<String, Object>> getSaleOrderAndMaterialById(Map<String,Object> mapValue);
}